/* Tabela MAPARECUP: Detalhamento dos valores do Mapa de Apurao */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MAPARECUP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela de Detalhamento do Mapa de Apurao,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_MAPARECUP
AFTER DELETE OR INSERT OR UPDATE
ON MAPARECUP FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(50);
   V_DSREMOTEHOST VARCHAR2(50);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(50);
   V_DSREMOTEOPER VARCHAR2(12);
   V_NMOPERADOR   VARCHAR2(100);
   V_TIPO         VARCHAR2(1);
   V_DESC         VARCHAR2(1000);
   V_CDFILLOGOPER VARCHAR2(4);
   V_ITPESQ       VARCHAR2(40);
   V_DTOPER       DATE;
   V_STATUS       VARCHAR2(10);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.VRNORMDEBI IS NOT NULL THEN
         V_DESC := V_DESC || 'DebNormal=' || :OLD.VRNORMDEBI;
      END IF;
      IF :OLD.VROUTRDEBI IS NOT NULL THEN
         V_DESC := V_DESC || ' OutrosDeb=' || :OLD.VROUTRDEBI;
      END IF;
      IF :OLD.VRESTOCRED IS NOT NULL THEN
         V_DESC := V_DESC || ' EstornoCred=' || :OLD.VRESTOCRED;
      END IF;
      IF :OLD.VRTOTADEBI IS NOT NULL THEN
         V_DESC := V_DESC || ' TotalDeb=' || :OLD.VRTOTADEBI;
      END IF;
      IF :OLD.VRNORMCRED IS NOT NULL THEN
         V_DESC := V_DESC || ' CredNormal=' || :OLD.VRNORMCRED;
      END IF;
      IF :OLD.VROUTRCRED IS NOT NULL THEN
         V_DESC := V_DESC || ' OutrosCred=' || :OLD.VROUTRCRED;
      END IF;
      IF :OLD.VRESTODEBI IS NOT NULL THEN
         V_DESC := V_DESC || ' EstornoDeb=' || :OLD.VRESTODEBI;
      END IF;
      IF :OLD.VRTOTACRED IS NOT NULL THEN
         V_DESC := V_DESC || ' TotalCred=' || :OLD.VRTOTACRED;
      END IF;
      IF :OLD.VRDEDUCAO IS NOT NULL THEN
         V_DESC := V_DESC || ' Deducao=' || :OLD.VRDEDUCAO;
      END IF;
      IF :OLD.VRSLDCRANTE IS NOT NULL THEN
         V_DESC := V_DESC || ' CredAnterior=' || :OLD.VRSLDCRANTE;
      END IF;
      IF :OLD.VRSALDOCRED IS NOT NULL THEN
         V_DESC := V_DESC || ' SaldoCredor=' || :OLD.VRSALDOCRED;
      END IF;
      IF :OLD.VRSALDODEBI IS NOT NULL THEN
         V_DESC := V_DESC || ' SaldoDevedor=' || :OLD.VRSALDODEBI;
      END IF;
      IF :OLD.VRDIFALIQU IS NOT NULL THEN
         V_DESC := V_DESC || ' DifAliquota=' || :OLD.VRDIFALIQU;
      END IF;
      IF :OLD.VRIMPCARGATRIBM IS NOT NULL THEN
         V_DESC := V_DESC || ' CargaTributaria=' || :OLD.VRIMPCARGATRIBM;
      END IF;
      IF :OLD.VRFATBRUTOMAPR IS NOT NULL THEN
         V_DESC := V_DESC || ' FaturamentoBruto=' || :OLD.VRFATBRUTOMAPR;
      END IF;
      IF :OLD.VRDIFALNC IS NOT NULL THEN
         V_DESC := V_DESC || ' DifAliqNaoContrib=' || :OLD.VRDIFALNC;
      END IF;
      IF :OLD.VRFCPNC IS NOT NULL THEN
         V_DESC := V_DESC || ' FCPNaoContrib=' || :OLD.VRFCPNC;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRSEQUMAPAPU;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.VRNORMDEBI, 0)      <> NVL(:OLD.VRNORMDEBI, 0)      OR
            NVL(:NEW.VROUTRDEBI, 0)      <> NVL(:OLD.VROUTRDEBI, 0)      OR
            NVL(:NEW.VRESTOCRED, 0)      <> NVL(:OLD.VRESTOCRED, 0)      OR
            NVL(:NEW.VRTOTADEBI, 0)      <> NVL(:OLD.VRTOTADEBI, 0)      OR
            NVL(:NEW.VRNORMCRED, 0)      <> NVL(:OLD.VRNORMCRED, 0)      OR
            NVL(:NEW.VROUTRCRED, 0)      <> NVL(:OLD.VROUTRCRED, 0)      OR
            NVL(:NEW.VRESTODEBI, 0)      <> NVL(:OLD.VRESTODEBI, 0)      OR
            NVL(:NEW.VRTOTACRED, 0)      <> NVL(:OLD.VRTOTACRED, 0)      OR
            NVL(:NEW.VRDEDUCAO, 0)       <> NVL(:OLD.VRDEDUCAO,  0)      OR
            NVL(:NEW.VRSLDCRANTE, 0)     <> NVL(:OLD.VRSLDCRANTE, 0)     OR
            NVL(:NEW.VRSALDOCRED, 0)     <> NVL(:OLD.VRSALDOCRED, 0)     OR
            NVL(:NEW.VRSALDODEBI, 0)     <> NVL(:OLD.VRSALDODEBI, 0)     OR
            NVL(:NEW.VRDIFALIQU, 0)      <> NVL(:OLD.VRDIFALIQU, 0)      OR
            NVL(:NEW.VRIMPCARGATRIBM, 0) <> NVL(:OLD.VRIMPCARGATRIBM, 0) OR
            NVL(:NEW.VRFATBRUTOMAPR, 0)  <> NVL(:OLD.VRFATBRUTOMAPR, 0)  OR
            NVL(:NEW.VRDIFALNC, 0)       <> NVL(:OLD.VRDIFALNC, 0)       OR
            NVL(:NEW.VRFCPNC, 0)         <> NVL(:OLD.VRFCPNC, 0)         THEN
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRSEQUMAPAPU;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRSEQUMAPAPU;
      END IF;

      IF NVL(:NEW.VRNORMDEBI, 0) <> NVL(:OLD.VRNORMDEBI, 0) THEN
         V_DESC := V_DESC || 'DebNormal=' || :NEW.VRNORMDEBI;
      END IF;
      IF NVL(:NEW.VROUTRDEBI, 0) <> NVL(:OLD.VROUTRDEBI, 0) THEN
         V_DESC := V_DESC || ' OutrosDeb=' || :NEW.VROUTRDEBI;
      END IF;
      IF NVL(:NEW.VRESTOCRED, 0) <> NVL(:OLD.VRESTOCRED, 0) THEN
         V_DESC := V_DESC || ' EstornoCred=' || :NEW.VRESTOCRED;
      END IF;
      IF NVL(:NEW.VRTOTADEBI, 0) <> NVL(:OLD.VRTOTADEBI, 0) THEN
         V_DESC := V_DESC || ' TotalDeb=' || :NEW.VRTOTADEBI;
      END IF;
      IF NVL(:NEW.VRNORMCRED, 0) <> NVL(:OLD.VRNORMCRED, 0) THEN
         V_DESC := V_DESC || ' CredNormal=' || :NEW.VRNORMCRED;
      END IF;
      IF NVL(:NEW.VROUTRCRED, 0) <> NVL(:OLD.VROUTRCRED, 0) THEN
         V_DESC := V_DESC || ' OutrosCred=' || :NEW.VROUTRCRED;
      END IF;
      IF NVL(:NEW.VRESTODEBI, 0) <> NVL(:OLD.VRESTODEBI, 0) THEN
         V_DESC := V_DESC || ' EstornoDeb=' || :NEW.VRESTODEBI;
      END IF;
      IF NVL(:NEW.VRTOTACRED, 0) <> NVL(:OLD.VRTOTACRED, 0) THEN
         V_DESC := V_DESC || ' TotalCred=' || :NEW.VRTOTACRED;
      END IF;
      IF NVL(:NEW.VRDEDUCAO, 0) <> NVL(:OLD.VRDEDUCAO, 0) THEN
         V_DESC := V_DESC || ' Deducao=' || :NEW.VRDEDUCAO;
      END IF;
      IF NVL(:NEW.VRSLDCRANTE, 0) <> NVL(:OLD.VRSLDCRANTE, 0) THEN
         V_DESC := V_DESC || ' CredAnterior=' || :NEW.VRSLDCRANTE;
      END IF;
      IF NVL(:NEW.VRSALDOCRED, 0) <> NVL(:OLD.VRSALDOCRED, 0) THEN
         V_DESC := V_DESC || ' SaldoCredor=' || :NEW.VRSALDOCRED;
      END IF;
      IF NVL(:NEW.VRSALDODEBI, 0) <> NVL(:OLD.VRSALDODEBI, 0) THEN
         V_DESC := V_DESC || ' SaldoDevedor=' || :NEW.VRSALDODEBI;
      END IF;
      IF NVL(:NEW.VRDIFALIQU, 0) <> NVL(:OLD.VRDIFALIQU, 0) THEN
         V_DESC := V_DESC || ' DifAliquota=' || :NEW.VRDIFALIQU;
      END IF;
      IF NVL(:NEW.VRIMPCARGATRIBM, 0) <> NVL(:OLD.VRIMPCARGATRIBM, 0) THEN
         V_DESC := V_DESC || ' CargaTributaria=' || :NEW.VRIMPCARGATRIBM;
      END IF;
      IF NVL(:NEW.VRFATBRUTOMAPR, 0) <> NVL(:OLD.VRFATBRUTOMAPR, 0) THEN
         V_DESC := V_DESC || ' FaturamentoBruto=' || :NEW.VRFATBRUTOMAPR;
      END IF;
      IF NVL(:NEW.VRDIFALNC, 0) <> NVL(:OLD.VRDIFALNC, 0) THEN
         V_DESC := V_DESC || ' DifAliqNaoContrib=' || :NEW.VRDIFALNC;
      END IF;
	  IF NVL(:NEW.VRFCPNC, 0) <> NVL(:OLD.VRFCPNC, 0) THEN
         V_DESC := V_DESC || ' FCPNaoContrib=' || :NEW.VRFCPNC;
      END IF;
   END IF;

   IF  V_TIPO <> '0' THEN
       NMUSUARIO(V_NMOPERADOR);
       WEBTUNNING(V_DSREMOTEADDR,
                  V_DSREMOTEHOST,
                  V_DSSERVERRDM,
                  V_DSSERVMETHOD,
                  V_DSREMOTEOPER);

       IF NOT V_DESC IS NULL THEN
         IF NOT V_NMOPERADOR IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,   IDTIPOOPER,  CDPESQITEM,  DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER,CDORESPOPER)
            VALUES
               ('MAPARECUP',    V_DTOPER,      V_NMOPERADOR,   V_TIPO,         V_ITPESQ,       SUBSTR(V_DESC,1,400),
                V_CDFILLOGOPER, V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
       END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_MAPARECUP','5.87.000'); END;
/
